* Version 1.0
LPARAMETERS lcFileName,lnStartRows,lcSheet,lcTrue,lcFalse,llCursor,lnHeader
* lcFileName		name of the document
					* nom de document
					* numele documentului
* lnStartRows		starting row (the first lnStartRows - 1 rows are skipped) ; optional ; default 1 (all rows)
					* a partir range (les premiers lnStartRows - 1 lignes sont passes) ; optionnel ; dfaut 1 (tous les champs lignes)
					* primul rand (primele lnStartRows - 1 randuri ale tabelului din docx sunt omise); optional; implicit 1 (toate randurile)
* lcSheet			sheet name | number	; optional ; default ''
					* nom | nomber de la feuille ; optionnel ; dfaut ''
					* numele |numarul foii	; optional ; implicit ''
* lcTrue			the text representing "true" for boolean fields ; optional ; default "true"
					* le texte reprsentant "true" pour les champs boolens; optionnel; dfaut "true"
					* textul prin care e reprezentat "true", pentru campurile booleene; optional; implicit "true"
* lcFalse			the text representing "false" for boolean fields ; optional ; default "false"
					* le texte reprsentant "false" pour les champs boolens; optionnel; dfaut "false"
					* textul prin care e reprezentat "false", pentru campurile booleene; optional; implicit "false"
* llCursor			when .T., the result is a cursor instead of a DBF ; optional ; default .F.
					* lorsque .T, le rsultat est un cursor au lieu d'un DBF; optionnel; dfaut .F.
					* cand este .T., rezultatul este un cursor si nu un DBF; optional; implicit .F.
* lnHeader			the row that contains column headers (lnHeader < lnStartRows); optional ; default 0
					* nombre de la ligne d'en-tte (lnHeader < lnStartRows); optionnel ; dfaut 0
					* linia care contine antetele coloanelor (lnHeader < lnStartRows); optional; implicit 0
DECLARE Sleep IN WIN32API INTEGER 
#DEFINE ERRLANG "En"
#IF ERRLANG = "Ro"
	#DEFINE ERRMESS0 "Eroare"
	#DEFINE ERRMESS1 "Nimic de importat"
	#DEFINE ERRMESS3 "Foaie inexistenta"
	#DEFINE ERRMESS4 "Eroare la deschiderea"
#ELIF ERRLANG = "Fr"
	#DEFINE ERRMESS0 "Erreur"
	#DEFINE ERRMESS1 "Rien a ajouter"
	#DEFINE ERRMESS3 "Feuille introuvable"
	#DEFINE ERRMESS4 "Erreur d'ouverture"
#ELIF ERRLANG = "Nl" && Koen Piller
	#DEFINE ERRMESS0 "Fout"
	#DEFINE ERRMESS1 "Niets te importeren"
	#DEFINE ERRMESS3 "Blad nietb gevonden"
	#DEFINE ERRMESS4 "Fout bij openen"
#ELSE
	#DEFINE ERRMESS0 "Error"
	#DEFINE ERRMESS1 "Nothing to append"
	#DEFINE ERRMESS3 "Sheet not found"
	#DEFINE ERRMESS4 "Error opening"
#ENDIF

LOCAL lcDir,lSetTalk,lnFFields,laFFields[1],lnColsNoAll,laFieldsAll[1],lnColsNo,laFields[1,18],lnCurCol,llMemos,lnSelect,lcCur,lcDBF,lnFile,laFile[1],lni,lnTable,loXDOM 
lnSelect = SELECT(0)

IF PCOUNT() < 1 
	MESSAGEBOX(ERRMESS1,16,ERRMESS0)
	RETURN
ELSE
	IF VARTYPE(m.lcFileName) $ "CV"
		IF INLIST(LOWER(JUSTEXT(m.lcFileName)),"ods","odt","odp")
			IF ADIR(laFile, m.lcFileName) = 0
				MESSAGEBOX(ERRMESS1,16,ERRMESS0)
				RETURN
			ENDIF
		ELSE
			lnFile = 0
			FOR lni = 1 TO ADIR(laFile, FORCEEXT(m.lcFileName,'*'))
				IF INLIST(LOWER(JUSTEXT(m.laFile[m.lni,1])),"ods","odt","odp")
					lnFile = m.lni
					m.lcFileName = m.laFile[m.lni,1]
					EXIT
				ENDIF
			NEXT
			IF m.lnFile = 0
				MESSAGEBOX(ERRMESS1,16,ERRMESS0)
				RETURN
			ENDIF
		ENDIF
	ELSE
		MESSAGEBOX(ERRMESS1,16,ERRMESS0)
		RETURN
	ENDIF
ENDIF
IF PCOUNT() < 2
	lnStartRows = 1
ELSE
	IF VARTYPE(m.lnStartRows) <> "N"
		lnStartRows = 1
	ENDIF
ENDIF
IF PCOUNT()<3
	lcSheet = ""
ELSE
	IF NOT (VARTYPE(m.lcSheet) $ "CN")
		lcSheet = ""
	ENDIF
ENDIF
IF PCOUNT()<4
	lcTrue = "true"
ELSE
	IF VARTYPE(m.lcTrue) <> "C"
		lcTrue = "true"
	ELSE
		lcTrue = LOWER(m.lcTrue)
	ENDIF
ENDIF
IF PCOUNT()<5
	lcFalse = "false"
ELSE
	IF VARTYPE(m.lcFalse) <> "C"
		lcFalse = "false"
	ELSE
		lcFalse = LOWER(m.lcFalse)
	ENDIF
ENDIF
IF PCOUNT() < 6
	llCursor = .F.
ELSE
	IF VARTYPE(m.llCursor) <> "L"
		llCursor = .F.
	ENDIF
ENDIF
IF PCOUNT() < 7
	lnHeader = 0
ELSE
	IF VARTYPE(m.lnHeader) <> "N"
		lnHeader = 0
	ENDIF
ENDIF
IF m.lnHeader >= m.lnStartRows
	lnHeader = 0
ENDIF

lSetTalk = SET("Talk")
SET TALK OFF 

lcDir = extract(m.lcFileName)
lcDBF = ""

lnTable = get_sheet(ADDBS(m.lcDir) + "content.xml",m.lcSheet)
IF m.lnTable = 0
	MESSAGEBOX(ERRMESS3,16,'Error')
	cleanup(m.lcDir,@loXDOM)
	SET TALK &lSetTalk
	SELECT (m.lnSelect)
	RETURN m.lcDBF
ENDIF

lcCur = gen_table(ADDBS(m.lcDir) + "content.xml",@lnStartRows,m.lnTable,@lnColsNo,@laFields,m.lcTrue,m.lcFalse,@lnHeader,m.llCursor,@loXDOM)
IF EMPTY(m.lcCur)
	MESSAGEBOX(ERRMESS1,16,'Error')
	cleanup(m.lcDir,@loXDOM)
	SET TALK &lSetTalk
	SELECT (m.lnSelect)
	RETURN m.lcDBF
ENDIF

lcDBF = get_cells(ADDBS(m.lcDir) + "content.xml",m.lnStartRows,m.lnTable,lnColsNo,@laFields,m.lcCur,m.lcFileName,m.lcTrue,m.lcFalse,m.llCursor,@loXDOM)
cleanup(m.lcDir,@loXDOM)
IF USED(m.lcCur)
	USE IN (m.lcCur)
ENDIF
SET TALK &lSetTalk
SELECT (m.lnSelect)
RETURN m.lcDBF

*********************
* Extract xml files *
*********************
FUNCTION extract
	LPARAMETERS lcFileName
	LOCAL lcDir,lcZip,oShell,ofile,loErr as Exception,lcSetSaf,lni,lnFF
	lcDir = ADDBS(SYS(2023)) + SYS(2015)
	lcZip = FORCEEXT(m.lcDir,'.zip')
	COPY FILE (m.lcFileName) TO (m.lcZip)
	MD (m.lcDir)
	oShell = CREATEOBJECT("shell.application")
	TRY
		FOR lni = 0 TO m.oShell.NameSpace(m.lcZip).items.count - 1
			ofile = m.oShell.NameSpace(m.lcZip).items.item(m.lni)
			IF m.ofile.name == 'content.xml'
				oShell.NameSpace( m.lcDir).copyhere( m.ofile)
				lnFF = FOPEN(ADDBS(lcDir) + m.ofile.name)
				DO WHILE m.lnFF < 0
					sleep(50)
					lnFF = FOPEN(m.ofile.name)
				ENDDO
				FCLOSE(m.lnFF)
			ENDIF
		ENDFOR
	CATCH TO loErr
	ENDTRY
RETURN lcDir
	

**********************************************
* Read first row and determine the data type *
**********************************************
FUNCTION gen_table
	LPARAMETERS lcStr,lnStartRows,lnTable,lnField,laFieldGat,lcTrue,lcFalse,lnHeader,llCursor,loXDOM
	LOCAL lcSetDec,lnCurRow,lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal,lcPoint,llNumber,llDate,llTime,llBool,lcTable,lcTextPiece,lnPar,lcPar,lcWholeWal,lnName,lcName
	LOCAL lnLeftName,lnFieldF,lnSpan,lcSpan,lnFieldExtr,lcPar1,lcXmlType,lcXmlVal,lcCell1
	LOCAL loTables, loTable, loRows, loRow,lnNoOfRows,loCells, loCell, lnNoOfCells, lnFinalDim, loPars, loPar, lnNoOfPars,lnCell,lnCurField
	loXDOM = CREATEOBJECT('MSXML2.DOMDocument')	
	loXDOM.Load(m.lcStr)
	loTables = loXDOM.getElementsByTagName("table:table")
	lnNoOfTables = loTables.Length
	
	lcTable = SYS(2015)
	lcPoint = SET("Point")
	
	IF m.lnNoOfTables < m.lnTable
		MESSAGEBOX(ERRMESS3,16,ERRMESS0)
		RETURN ''
	ENDIF
	
	loTable = loTables.Item(m.lnTable - 1)
	loRows = loTable.getElementsByTagName("table:table-row")
	lnNoOfRows = loRows.Length
	IF m.lnNoOfRows < m.lnStartRows
		MESSAGEBOX(ERRMESS3,16,ERRMESS0)
		RETURN ''
	ENDIF
	
	lnFinalDim = 0
	FOR lni = m.lnStartRows - 1 TO m.loRows.Length - 1
		loCells = loRows.Item(m.lni).getElementsByTagName("table:table-cell")
		lnNoOfCells = m.loCells.Length
		lnSpan = 0
		FOR lnCell = 0 TO m.lnNoOfCells - 1
			lcSpan = NVL(loCells.Item(m.lnCell).getAttribute ("table:number-columns-spanned"),"")
			IF !EMPTY(m.lcSpan)
				lnSpan = m.lnSpan + MAX(VAL(m.lcSpan) - 1,0)
			ENDIF
			lcSpan = NVL(loCells.Item(m.lnCell).getAttribute ("table:number-columns-repeated"),"")
			IF !EMPTY(m.lcSpan)
				lnSpan = m.lnSpan + MAX(VAL(m.lcSpan),0)
			ENDIF
		NEXT
		IF m.lnFinalDim < m.lnNoOfCells + m.lnSpan
			lnFinalDim = m.lnNoOfCells + m.lnSpan
		ENDIF
	NEXT
	
	IF m.lnHeader > 0
		loRow = loRows.Item(m.lnHeader - 1)
		loCells = loRow.getElementsByTagName("table:table-cell")
		lnNoOfCells = m.loCells.Length
	ENDIF
	DIMENSION laFieldGat[m.lnFinalDim,18]
	FOR lni = 1 TO m.lnFinalDim
		STORE 0 TO laFieldGat[m.lni,17],laFieldGat[m.lni,18],laFieldGat[m.lni,4]
		STORE .T. TO laFieldGat[m.lni,5]
		STORE .F. TO laFieldGat[m.lni,6],laFieldGat[m.lni,5]
		STORE '' TO laFieldGat[m.lni,7],laFieldGat[m.lni,8],laFieldGat[m.lni,9],laFieldGat[m.lni,10],laFieldGat[m.lni,11],laFieldGat[m.lni,12],laFieldGat[m.lni,13],laFieldGat[m.lni,14],laFieldGat[m.lni,15],laFieldGat[m.lni,16]
		laFieldGat[m.lni,1] = "MFIELD"+TRANSFORM(m.lni)
	NEXT
	IF m.lnHeader > 0
		lnCurField = 1
		FOR lnFieldExtr = 0 TO m.lnNoOfCells - 1
			loCell = loCells.Item(m.lnFieldExtr)
			lnSpan = 0
			lcSpan = NVL(loCell.getAttribute ("table:number-columns-spanned"),"")
			IF !EMPTY(m.lcSpan)
				lnSpan = MAX(VAL(m.lcSpan) - 1,0)
			ENDIF
			lcSpan = NVL(loCell.getAttribute ("table:number-columns-repeated"),"")
			IF !EMPTY(m.lcSpan)
				lnCurField = m.lnCurField + MAX(VAL(m.lcSpan),0)
			ENDIF
			loPars = loCell.getElementsByTagName("text:p")
			loNoOfPars = loPars.Length
			lcCell = ''
			FOR lnFieldF = 0 TO m.loNoOfPars - 2
				lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.lnFieldF).nodeTypedValue + CHR(13)
			NEXT
			lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.loNoOfPars - 1).nodeTypedValue
			IF !EMPTY(m.lcCell)
				lcXmlType = NVL(loCell.getAttribute ("office:value-type"),"")
				IF m.lcXmlType = "float"
					lcXmlVal = NVL(loCell.getAttribute ("office:value"),"")
				ELSE
				IF m.lcXmlType = "date"
					lcXmlVal = NVL(loCell.getAttribute ("office:date-value"),"")
				ELSE
				IF m.lcXmlType = "time"
					lcXmlVal = NVL(loCell.getAttribute ("office:time-value"),"")
				ELSE
				IF m.lcXmlType = "boolean"
					lcXmlVal = NVL(loCell.getAttribute ("office:boolean-value"),"")
				ENDIF
				ENDIF
				ENDIF
				ENDIF
				llNumber = m.lcXmlType == "float" or EMPTY(CHRTRAN(m.lcCell,"0123456789+-" + m.lcPoint,"")) and ;
							OCCURS(m.lcPoint,m.lcCell) < 2 and ;
							OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) < 2 and ;
							IIF(OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) > 0, LEFT(LTRIM(m.lcCell),1) $ "+-", .T.) ;
							and AT(CHR(13),m.lcCell) = 0
				llDate = m.lcXmlType = "date" and LEN(m.lcXmlVal) = 10 or !EMPTY(CTOD(m.lcCell))
				llTime = m.lcXmlType = "date" and LEN(m.lcXmlVal) > 10 or m.lcXmlType = "time" or !llDate and !EMPTY(CTOT(m.lcCell))
				llBool = m.lcXmlType = "boolean" or INLIST(LOWER(ALLTRIM(m.lcCell)),m.lcTrue,m.lcFalse)
				DO CASE
				CASE m.llNumber
					laFieldGat[m.lnCurField,1] = "_" + CHRTRAN(IIF(m.lcXmlType == "float", m.lcXmlVal,m.lcCell),'.,+-','')
				CASE m.llDate
					laFieldGat[m.lnCurField,1] = "_" + IIF(m.lcXmlType = "date",CHRTRAN(m.lcXmlVal,'-',''),DTOS(CTOD(m.lcCell)))
				CASE m.llTime
					laFieldGat[m.lnCurField,1] = "_" + IIF(m.lcXmlType = "date",m.lcXmlVal,IIF(m.lcXmlType = "time",DTOC(DATE(),1) + CHRTRAN(m.lcXmlVal,"PTHMS",""),TTOC(CTOT(m.lcCell),1)))
				CASE m.llBool
					laFieldGat[m.lnCurField,1] = m.lcCell
					laFieldGat[m.lnCurField,1] = UPPER(ALLTRIM(laFieldGat[m.lnCurField,1]))
					laFieldGat[m.lnCurField,1] = CHRTRAN(laFieldGat[m.lnCurField,1],CHRTRAN(laFieldGat[m.lnCurField,1],"_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ",""),"")
					IF !ISALPHA(laFieldGat[m.lnCurField,1])
						laFieldGat[m.lnCurField,1] = "_" + laFieldGat[m.lnCurField,1]
					ENDIF
					laFieldGat[m.lnCurField,1] = LEFT(laFieldGat[m.lnCurField,1],IIF(m.llCursor,31,10)) && 31
				OTHERWISE
					laFieldGat[m.lnCurField,1] = m.lcCell
					laFieldGat[m.lnCurField,1] = UPPER(ALLTRIM(laFieldGat[m.lnCurField,1]))
					laFieldGat[m.lnCurField,1] = CHRTRAN(laFieldGat[m.lnCurField,1],CHRTRAN(laFieldGat[m.lnCurField,1],"_0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ",""),"")
					IF !ISALPHA(laFieldGat[m.lnCurField,1])
						laFieldGat[m.lnCurField,1] = "_" + laFieldGat[m.lnCurField,1]
					ENDIF
					laFieldGat[m.lnCurField,1] = LEFT(laFieldGat[m.lnCurField,1],IIF(m.llCursor,31,10)) && 31
					lnName = 0
					lcName = laFieldGat[m.lnCurField,1]
					DO WHILE BETWEEN(ASCAN(laFieldGat,m.lcName,1,-1,1,1+2+4+8), 1, m.lnCurField - 1)
						lnName = m.lnName + 1
						lcName = laFieldGat[m.lnCurField,1]
						lnLeftName = MIN(LEN(laFieldGat[m.lnCurField,1]) , IIF(m.llCursor,31,10) - LEN(TRANSFORM(m.lnName))) && 31
						lcName = LEFT(laFieldGat[m.lnCurField,1], m.lnLeftName) + TRANSFORM(m.lnName)
					ENDDO
					laFieldGat[m.lnCurField,1] = m.lcName

				ENDCASE
			ENDIF
			lnCurField = m.lnCurField + 1 + m.lnSpan
		NEXT
	ENDIF
	loRow = loRows.Item(m.lnStartRows - 1)
	loCells = loRow.getElementsByTagName("table:table-cell")
	lnNoOfCells = m.loCells.Length
	IF m.lnFinalDim < m.lnNoOfCells
		lnFinalDim = m.lnNoOfCells
	ENDIF
	lnCurField = 1
	FOR lnFieldExtr = 0 TO m.lnNoOfCells - 1
		loCell = loCells.Item(m.lnFieldExtr)
		lnSpan = 0
		lcSpan = NVL(loCell.getAttribute ("table:number-columns-spanned"),"")
		IF !EMPTY(m.lcSpan)
			lnSpan = MAX(VAL(m.lcSpan) - 1,0)
		ENDIF
		lcSpan = NVL(loCell.getAttribute ("table:number-columns-repeated"),"")
		IF !EMPTY(m.lcSpan)
			FOR lni = m.lnCurField TO m.lnCurField + MAX(VAL(m.lcSpan),0) - 1
				laFieldGat[m.lnCurField,2] = "M"
				laFieldGat[m.lnCurField,3] = 4
			NEXT 
			lnCurField = m.lnCurField + MAX(VAL(m.lcSpan),0)
		ENDIF
		loPars = loCell.getElementsByTagName("text:p")
		loNoOfPars = loPars.Length
		IF m.loNoOfPars = 0
			laFieldGat[m.lnCurField,2] = "M"
			laFieldGat[m.lnCurField,3] = 4
			LOOP
		ENDIF		
		lcCell = ''
		FOR lnFieldF = 0 TO m.loNoOfPars - 2
			lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.lnFieldF).nodeTypedValue + CHR(13)
		NEXT
		lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.loNoOfPars - 1).nodeTypedValue
		IF !EMPTY(m.lcCell)
			lcXmlType = NVL(loCell.getAttribute ("office:value-type"),"")
			IF m.lcXmlType = "float"
				lcXmlVal = NVL(loCell.getAttribute ("office:value"),"")
			ELSE
			IF m.lcXmlType = "date"
				lcXmlVal = NVL(loCell.getAttribute ("office:date-value"),"")
			ELSE
			IF m.lcXmlType = "time"
				lcXmlVal = NVL(loCell.getAttribute ("office:time-value"),"")
			ELSE
			IF m.lcXmlType = "boolean"
				lcXmlVal = NVL(loCell.getAttribute ("office:boolean-value"),"")
			ENDIF
			ENDIF
			ENDIF
			ENDIF
			llNumber = m.lcXmlType == "float" or EMPTY(CHRTRAN(m.lcCell,"0123456789+-" + m.lcPoint,"")) and ;
						OCCURS(m.lcPoint,m.lcCell) < 2 and ;
						OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) < 2 and ;
						IIF(OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) > 0, LEFT(LTRIM(m.lcCell),1) $ "+-", .T.) ;
						and AT(CHR(13),m.lcCell) = 0
			llDate = m.lcXmlType = "date" and LEN(m.lcXmlVal) = 10 or !EMPTY(CTOD(m.lcCell))
			llTime = m.lcXmlType = "date" and LEN(m.lcXmlVal) > 10 or m.lcXmlType = "time" or !llDate and !EMPTY(CTOT(m.lcCell))
			llBool = m.lcXmlType = "boolean" or INLIST(LOWER(ALLTRIM(m.lcCell)),m.lcTrue,m.lcFalse)
			DO CASE
			CASE m.llNumber
				laFieldGat[m.lnCurField,2] = "B"
				laFieldGat[m.lnCurField,3] = 8
				laFieldGat[m.lnCurField,4] = 15
			CASE m.llDate
				laFieldGat[m.lnCurField,2] = "D"
				laFieldGat[m.lnCurField,3] = 8
			CASE m.llTime
				laFieldGat[m.lnCurField,2] = "T"
				laFieldGat[m.lnCurField,3] = 8
			CASE m.llBool
				laFieldGat[m.lnCurField,2] = "L"
				laFieldGat[m.lnCurField,3] = 1
			OTHERWISE
				laFieldGat[m.lnCurField,2] = "M"
				laFieldGat[m.lnCurField,3] = 4
			ENDCASE
		ELSE
			laFieldGat[m.lnCurField,2] = "M"
			laFieldGat[m.lnCurField,3] = 4
		ENDIF
		FOR lni = 1 TO m.lnSpan
			laFieldGat[m.lnCurField + m.lni,2] = "M"
			laFieldGat[m.lnCurField + m.lni,3] = 4
		NEXT
		lnCurField = m.lnCurField + 1 + m.lnSpan
	NEXT
	FOR lnFieldExtr = m.lnNoOfCells + 1 TO m.lnFinalDim
		laFieldGat[m.lnFieldExtr,2] = "M"
		laFieldGat[m.lnFieldExtr,3] = 4
	NEXT
	lnField = MIN(m.lnFinalDim,254)
	IF m.lnFinalDim > 254
		DIMENSION laFieldGat[m.lnField , ALEN(laFieldGat,2)]
	ENDIF
	IF lnField = 0
		lcTable = ''
	ELSE
		CREATE CURSOR (m.lcTable) FROM ARRAY laFieldGat
	ENDIF
RETURN m.lcTable

*****************
* Read document *
*****************
FUNCTION get_cells
	LPARAMETERS lcStr,lnStartRows,lnTable,lnField,laField,cCur,lcFileName,lcTrue,lcFalse,llCursor,loXDOM
	LOCAL lcSetDec,lnCurRow,lni,lcWholeDoc,lnNoOfTables,lcWholeTable,lcWholeRow,lcCell,lcVal,laFieldGat[1],laFieldPrec[m.lnField,2],lcPoint,lcTable,lcTextPiece,lnPar,lcPar,lcWholeWal
	LOCAL llNumber,llDate,llTime,llBool,lnSpan,lcSpan,lnFieldExtr,lnj,lcPar1,lcCell1,llEmptyPar
	LOCAL loTables, loTable, loRows, loRow,lnNoOfRows,loCells, loCell, lnNoOfCells, lnFinalDim, loPars, loPar, lnNoOfPars,lnCell,lnCurField

	lcSetDec = SET("Decimals")
	lcPoint = SET("Point")
	laFieldPrec = 0
	SET DECIMALS TO 10
	lcTable = FORCEEXT(m.lcFileName,"DBF")
	
	loTables = loXDOM.getElementsByTagName("table:table")
	loTable = loTables.Item(m.lnTable - 1)
	loRows = loTable.getElementsByTagName("table:table-row")
	lnNoOfRows = loRows.Length
	FOR lni = m.lnStartRows - 1 TO m.loRows.Length - 1
		loCells = loRows.Item(m.lni).getElementsByTagName("table:table-cell")
		lnNoOfCells = m.loCells.Length

		SELECT (m.cCur)
		APPEND BLANK
		SCATTER MEMO TO laFieldGat

		IF m.lnNoOfCells = 0
			LOOP
		ENDIF
		lnCurField = 1
		FOR lnFieldExtr = 0 TO m.lnNoOfCells - 1
			loCell = loCells.Item(m.lnFieldExtr)
			lnSpan = 0
			lcSpan = NVL(loCell.getAttribute ("table:number-columns-spanned"),"")
			IF !EMPTY(m.lcSpan)
				lnSpan = MAX(VAL(m.lcSpan) - 1,0)
			ENDIF
			lcSpan = NVL(loCell.getAttribute ("table:number-columns-repeated"),"")
			IF !EMPTY(m.lcSpan)
				lnCurField = m.lnCurField + MAX(VAL(m.lcSpan),0)
			ENDIF
			loPars = loCell.getElementsByTagName("text:p")
			loNoOfPars = loPars.Length
			IF m.loNoOfPars = 0
				LOOP
			ENDIF		
			lcCell = ''
			FOR lnFieldF = 0 TO m.loNoOfPars - 2
				lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.lnFieldF).nodeTypedValue + CHR(13)
			NEXT
			lcCell = m.lcCell + loCell.getElementsByTagName("text:p").Item(m.loNoOfPars - 1).nodeTypedValue
			IF !EMPTY(m.lcCell)
				lcXmlType = NVL(loCell.getAttribute ("office:value-type"),"")
				IF m.lcXmlType = "float"
					lcXmlVal = NVL(loCell.getAttribute ("office:value"),"")
				ELSE
				IF m.lcXmlType = "date"
					lcXmlVal = NVL(loCell.getAttribute ("office:date-value"),"")
				ELSE
				IF m.lcXmlType = "time"
					lcXmlVal = NVL(loCell.getAttribute ("office:time-value"),"")
				ELSE
				IF m.lcXmlType = "boolean"
					lcXmlVal = NVL(loCell.getAttribute ("office:boolean-value"),"")
				ENDIF
				ENDIF
				ENDIF
				ENDIF
				llNumber = m.lcXmlType == "float" or EMPTY(CHRTRAN(m.lcCell,"0123456789+-" + m.lcPoint,"")) and ;
							OCCURS(m.lcPoint,m.lcCell) < 2 and ;
							OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) < 2 and ;
							IIF(OCCURS("+",m.lcCell) + OCCURS("-",m.lcCell) > 0, LEFT(LTRIM(m.lcCell),1) $ "+-", .T.) ;
							and AT(CHR(13),m.lcCell) = 0
				llDate = m.lcXmlType = "date" and LEN(m.lcXmlVal) = 10 or !EMPTY(CTOD(m.lcCell))
				llTime = m.lcXmlType = "date" and LEN(m.lcXmlVal) > 10 or m.lcXmlType = "time" or !llDate and !EMPTY(CTOT(m.lcCell))
				llBool = m.lcXmlType = "boolean" or INLIST(LOWER(ALLTRIM(m.lcCell)),m.lcTrue,m.lcFalse)


				IF laField[m.lnCurField,2] == "M"
					laFieldGat[m.lnCurField] = htmspec(m.lcCell)
					laFieldPrec[m.lnCurField,1] = MAX(laFieldPrec[m.lnCurField,1],LEN(laFieldGat[m.lnCurField]))
					laFieldPrec[m.lnCurField,2] = MAX(laFieldPrec[m.lnCurField,2],OCCURS(CHR(13),laFieldGat[m.lnCurField]))
				ELSE
					IF laField[m.lnCurField,2] == "B"
						IF m.lcXmlType = "float"
							laFieldGat[m.lnCurField] = VAL(CHRTRAN(m.lcXmlVal,".",m.lcPoint))
							laFieldPrec[m.lnCurField,1] = MAX(laFieldPrec[m.lnCurField,1],LEN(ALLTRIM(m.lcXmlVal)))
							IF AT(".",ALLTRIM(m.lcXmlVal)) > 0 
								laFieldPrec[m.lnCurField,2] = MAX(laFieldPrec[m.lnCurField,2],LEN(ALLTRIM(m.lcXmlVal)) - AT(".",ALLTRIM(m.lcXmlVal)))
							ENDIF
						ELSE
							laFieldGat[m.lnCurField] = VAL(m.lcCell)
							laFieldPrec[m.lnCurField,1] = MAX(laFieldPrec[m.lnCurField,1],LEN(ALLTRIM(m.lcCell)))
							IF AT(m.lcPoint,ALLTRIM(m.lcCell)) > 0 
								laFieldPrec[m.lnCurField,2] = MAX(laFieldPrec[m.lnCurField,2],LEN(ALLTRIM(m.lcCell)) - AT(m.lcPoint,ALLTRIM(m.lcCell)))
							ENDIF
						ENDIF
					ELSE
						IF laField[m.lnCurField,2] $ "D"
							laFieldGat[m.lnCurField] = IIF(m.lcXmlType = "date",EVALUATE("DATE(" + CHRTRAN(m.lcXmlVal,"-",",") + ")"),CTOD(m.lcCell))
						ELSE
							IF laField[m.lnCurField,2] $ "T"
								laFieldGat[m.lnCurField] = CTOT(IIF(m.lcXmlType = "date",m.lcXmlVal,IIF(m.lcXmlType = "time",DTOC(DATE())+" "+m.lcCell,m.lcCell)))
							ELSE
								IF laField[m.lnCurField,2] $ "L"
									laFieldGat[m.lnCurField] = IIF(m.lcXmlType = "boolean",LOWER(m.lcXmlVal) == "true",LOWER(m.lcCell) == m.lcTrue)
								ENDIF
							ENDIF
						ENDIF
					ENDIF
				ENDIF
			ENDIF
			lnCurField = m.lnCurField + 1 + m.lnSpan
		NEXT
		SELECT (m.cCur)
		GATHER FROM laFieldGat MEMO
	NEXT
	SET DECIMALS TO &lcSetDec
	lcSql = "LPARAMETERS lcTable" + CHR(13) + "SELECT "
	FOR lni = 1 TO lnField
		IF laField[m.lni,2] == "M" AND BETWEEN(laFieldPrec[m.lni,1],1,254) AND laFieldPrec[m.lni,2] = 0
			lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS C(" + TRANSFORM(laFieldPrec[m.lni,1]) + ")) AS " + laField[m.lni,1] + ","
		ELSE
			IF laField[m.lni,2] == "B" AND BETWEEN(laFieldPrec[m.lni,1],1,20)
				IF laFieldPrec[m.lni,2] = 0 AND BETWEEN(laFieldPrec[m.lni,1],1,9)
					lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS I) AS " + laField[m.lni,1] + ","
				ELSE
					lcSql = m.lcSql + "CAST(" + laField[m.lni,1] + " AS N(" + TRANSFORM(laFieldPrec[m.lni,1]) + "," + TRANSFORM(laFieldPrec[m.lni,2]) + ")) AS " + laField[m.lni,1] + ","
				ENDIF
			ELSE
				lcSql = m.lcSql + laField[m.lni,1] + ","
			ENDIF
		ENDIF
	NEXT
	IF m.llCursor
		lcTable = SYS(2015) && CHRTRAN(JUSTSTEM(m.lcTable)," ","_")
		lcSql = RTRIM(m.lcSql,1,",") + " FROM " + m.cCur + " INTO CURSOR (m.lcTable) READWRITE"
		EXECSCRIPT(m.lcSql,m.lcTable)
	ELSE
		lcSql = RTRIM(m.lcSql,1,",") + " FROM " + m.cCur + " INTO TABLE (m.lcTable)" + CHR(13) + "RETURN ALIAS()"
		USE IN (EXECSCRIPT(m.lcSql,m.lcTable))
	ENDIF
	USE IN (m.cCur)
RETURN m.lcTable

**********************
* Special characters *
**********************
FUNCTION htmspec
	LPARAMETERS cStr
	LOCAL lni,lcStrF,lcChar,lnChar
	lcStrF = m.cStr
	IF AT('&gt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&gt;','>')
	ENDIF
	IF AT('&lt;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&lt;','<')
	ENDIF
	IF AT('&quot;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&quot;','"')
	ENDIF
	IF AT("&apos;",m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&apos;',"'")
	ENDIF
	IF AT([&#],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#]+STR(m.lnChar,3)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT([&#x],m.lcStrF)>0
		FOR lnChar = 0 TO 255
			lcChar = [&#x]+RIGHT(TRANSFORM(m.lnChar,"@0"),2)+[;]
			IF AT(m.lcChar,m.lcStrF)>0
				lcStrF = STRTRAN(m.lcStrF,m.lcChar,CHR(lnChar))
			ENDIF
		NEXT
	ENDIF
	IF AT('&amp;',m.lcStrF)>0
		lcStrF = STRTRAN(m.lcStrF,'&amp;',CHR(38))
	ENDIF

    * suggested by Koen Piller
	lcStrF = STRCONV(m.lcStrF,11)
	RETURN m.lcStrF
ENDFUNC

*****************
* Cleanup
******************
FUNCTION cleanup
	LPARAMETERS lcDir,loXDOM
	LOCAL lcZip,lcSetSaf
	RELEASE loXDOM
	lcZip = FORCEEXT(m.lcDir,'zip')
	lcSetSaf = SET("Safety")
	SET SAFETY OFF
	TRY 
		ERASE (ADDBS(m.lcDir)+'*.*')
		RD (m.lcDir)
	CATCH TO m.loErr
	ENDTRY

	ERASE (m.lcZip)
	SET SAFETY &lcSetSaf
RETURN .T.

*******************
* Read sheet name *
*******************
FUNCTION get_sheet
LPARAMETERS lcStr,lcSheet
	LOCAL lcWholeDoc,lnSheet,lcCurSheet,llFound
	lcWholeDoc = FILETOSTR(m.lcStr)
	IF VARTYPE(m.lcSheet) == "C"
		IF EMPTY(m.lcSheet)
			lnSheet = 1
		ELSE
			lnSheet = 1
			llFound = .F.
			lcCurSheet = STREXTRACT(m.lcWholeDoc,[<table:table ],[>],m.lnSheet)
			DO WHILE !m.llFound AND !EMPTY(m.lcCurSheet)
				IF ATC([table:name="] + m.lcSheet + ["],m.lcCurSheet) > 0
					llFound = .T.
					EXIT
				ENDIF
				lnSheet = m.lnSheet + 1
				lcCurSheet = STREXTRACT(m.lcWholeDoc,[<table:table ],[>],m.lnSheet)
			ENDDO
			IF !m.llFound
				lnSheet = 0
			ENDIF
		ENDIF
	ELSE
		IF OCCURS([<table:table],m.lcWholeDoc) < m.lcSheet
			lnSheet = 0
		ELSE
			lnSheet = m.lcSheet
		ENDIF
	ENDIF
RETURN m.lnSheet
